// robotic microhandling 
// control 4 servo through processing sketch
// Need G4P library download at 
// http://www.processing.org/reference/libraries/  
// Graphic Interface - G4P
// control servo on Arduino through GUI control
import processing.serial.*;
import cc.arduino.*;
import guicomponents.*;

GWSlider sdr4;

PImage rear;
Arduino arduino; // Declare object (a variable of type arduino object)
int timeupdw = 1500;       // store time microsec value 90°
int timelfrg = 1500;     // store time microsec value 90°
int timebkfw = 1500;     // store time microsec value 90°
int timerltk = 1500;  // store time microsec value 90°
int linea1 = 63;      // store the line position of up-down servo
//int stepslow = 1;        // store step value
int step = 1;

//declare pin where servo are attached
int servoPin3  = 9; //up-down
int servoPin5  = 3; //left-right
int servoPin6  = 5; //back-forward
int servoPin9  = 11; //take-release

// boolean variable coincident with the buttons
boolean up = true; 
boolean down = true;
boolean fast = true;
boolean slow = true;
boolean left = true;
boolean right = true;
boolean back = true;
boolean forward = true;
boolean release = true;
boolean take = true;  
boolean zero = true;

PFont f; 

void setup() {
  //size(410, 380);
  size(410, 607);
  
  rear = loadImage("realsteel.jpg");
  f = loadFont("Arial-BoldMT-48.vlw");
 
  println(Arduino.list());
  //create a new arduino object and pass parameters( "this" refers to this sketch, name of serial port, speed)
  arduino = new Arduino(this, Arduino.list()[0], 57600);

  // attaches the servo on pin 3 to the servo object You need to set the mode of the pin that the servo is attached to, to SERVO
  arduino.pinMode(servoPin3, Arduino.SERVO);
  // attaches the servo on pin 5 to the servo object 
  //arduino.servoAttach(servoPin5);

  createGUI();
  customGUI();
  // Place your setup code here
  background(rear);
}

void draw() {

  //700 and 2300 


  if ( zero ) {
  }
  else {
    println (" zero è cambiato " + zero );
    slow = true;
    fast = true;
    zero = true;
  }

  if ( fast ) {
  }
  else {

    println (" fast è cambiato " + fast );
    // Slider with another custom skin
    background(rear);
   // sdr1 = new GWSlider(this,90,570,260);
    sdr4 = new GWSlider(this, "purple18px",80,580, 260);
    sdr4.setInertia(10);

   // step = slider.getValue();
  }

  if ( slow ) {
  }
  else {

    println (" slow è cambiato " + slow );

    step = 1;

    // zero = true;
  }

  if ( up ) {
  }
  else {
    println (" up è cambiato " + timeupdw );
    timeupdw +=step;
    // up in steps of 1 microsec 
    arduino.analogWrite(servoPin3, timeupdw);
    delay(20);
    background(rear);
    textFont(f, 16);
    fill(204);
    text(timeupdw, 50, 70);
    up = true;
  }

  if ( down ) {
  }
  else {

    println (" down è cambiato " + timeupdw );
    timeupdw -= step;
    // in steps of 1 degree
    arduino.analogWrite(servoPin3, timeupdw);
    delay(20);
    background(rear);
    textFont(f, 16);
    fill(204);
    text(timeupdw, 50, 70);
    down = true;
  }

  if ( left ) {
  }
  else {

    println (" left è cambiato " + timelfrg );
    timelfrg -= step;
    // in steps of 1 degree 
    arduino.analogWrite(servoPin5, timelfrg);
    delay(20);
    background(rear);
    textFont(f, 16);
    fill(204);
    text(timelfrg, 50, 200);
    left = true;
  }

  if ( right ) {
  }
  else {

    println (" right è cambiato " + timelfrg );
    timelfrg += step;
    // in steps of 1 degree 
    arduino.analogWrite(servoPin5, timelfrg);
    delay(20);
    background(rear);
    textFont(f, 16);
    fill(204);
    text(timelfrg, 50, 200);
    right = true;
  }

  if ( back ) {
  }
  else {

    println (" back è cambiato " + timebkfw );
    timebkfw += step;
    // in steps of 1 degree 
    arduino.analogWrite(servoPin6, timebkfw);
    delay(20);
    background(rear);
    textFont(f, 26);
    fill(0xFFCCFF00);
    text(timebkfw, 110, 290);
    back = true;
  }

  if ( forward ) {
  }
  else {

    println (" forward è cambiato " + timebkfw );
    timebkfw -= step;
    // in steps of 1 degree 
    arduino.analogWrite(servoPin6, timebkfw);
    delay(20);
    background(rear);
    textFont(f, 26);
    fill(0xFFCCFF00);
    text(timebkfw, 110, 290);
    forward = true;
  }

  if ( release ) {
  }
  else {

    println (" release è cambiato " + timerltk );
    timerltk += step;
    // in steps of 1 degree 
    arduino.analogWrite(servoPin9, timerltk);
    delay(20);
    background(rear);
    textFont(f, 26);
    fill(0xFFCCFF00);
    text(timerltk, 280, 270);
    release = true;
  }

  if ( take ) {
  }
  else {

    println (" take è cambiato " + timerltk );
    timerltk -= step;
    // in steps of 1 degree 
    arduino.analogWrite(servoPin9, timerltk);
    delay(20);
    background(rear);
    textFont(f, 26);
    fill(0xFFCCFF00);
    text(timerltk, 280, 270);
    take = true;
  }
}

// Use this method to add additional statements
// to customise the GUI controls
void customGUI() {
}

void handleSliderEvents(GSlider slider) {
  println("integer value:" + slider.getValue());
  step = slider.getValue();
}

